#!/bin/sh
export HOME=/root
echo $PATH | grep /usr/local/bin >/dev/null || PATH=$PATH:/usr/local/bin
echo $PATH | grep /usr/local/sbin >/dev/null || PATH=$PATH:/usr/local/sbin
echo $PATH | grep /bin >/dev/null || PATH=$PATH:/bin
echo $PATH | grep /sbin >/dev/null || PATH=$PATH:/sbin
echo $PATH | grep /usr/bin >/dev/null || PATH=$PATH:/usr/bin
echo $PATH | grep /usr/sbin >/dev/null || PATH=$PATH:/usr/sbin
echo $PATH | grep /usr/X11R6/bin >/dev/null || PATH=$PATH:/usr/X11R6/bin

export PATH

MP3_APP=cm3s
TV_APP=xawtv
MOVI_APP=gmplayer

APPS="cm3s xawtv gmplayer"

kill_apps ()
{
  for APP in $APPS
  do
    #xawtv dose not like to be killed with -9 (leaves audio channel active)
    [ "$APP" = "xawtv" ] && killall xawtv > /dev/null || killall -s 9 $APP > /dev/null
  done
#this will kill any mp3 station lirc client hanging around
  killall -s 9 lirc_client 
}

power_mp3 ()
{
  COUNT=`ps -ef | grep -v grep | grep -c $MP3_APP`
  
  if [ $COUNT -lt 1 ]
  then
    echo on > /usr/local/remote/status
    kill_apps
    ( cd /mnt/media/mp3 ; /usr/local/bin/$MP3_APP )
#    /usr/local/bin/$MP3_APP -D /mnt/media/mp3
  else
    echo off > /usr/local/remote/status
    killall $MP3_APP > /dev/mull
  fi
}

power_lclient ()
{
  COUNT=`ps -ef | grep -v grep | grep -c lirc_client `
  XCOUNT=`ps -ef | grep -v grep | grep -c " X " `

  if [ $COUNT -lt 1 ]
  then
    if [ $XCOUNT -lt 1 ]
    then
      /usr/local/bin/lirc_client > /dev/tty1
    else
      xterm -e /usr/local/bin/lirc_client
    fi
  else
    killall -s 9 lirc_client
  fi
}

power_tv ()
{
  COUNT=`ps -ef | grep -v grep | grep -c $TV_APP `
  XCOUNT=`ps -ef | grep -v grep | grep -c " X " `

  if [ $COUNT -lt 1 ]
  then
    if [ $XCOUNT -lt 1 ]
    then
      echo on > /usr/local/remote/status
      startx &
    else
      echo on > /usr/local/remote/status
      kill_apps
      $TV_APP -f &
    fi
  else
    echo off > /usr/local/remote/status
    killall $TV_APP > /dev/null
  fi
}

power_movi ()
{
  COUNT=`ps -ef | grep -v grep | grep -c $MOVI_APP`
  XCOUNT=`ps -ef | grep -v grep | grep -c " X " `  
  if [ $COUNT -lt 1 ]
  then
    if [ $XCOUNT -lt 1 ]
    then
      echo on > /usr/local/remote/status
      startx &
    else
      kill_apps
      echo on > /usr/local/remote/status
#start moovie selector here
      ( cd /films ; $MOVI_APP & )
    fi
  else
    echo off > /usr/local/remote/status
    killall -s 9 $MOVI_APP > /dev/null
  fi
}

case $1 in
  tv|mp3|cd|radio|movi)  LAST=$1;;

  lclient) power_lclient
    exit 0 ;;

  *) [ -r /usr/local/remote/last_function ] && LAST=`cat /usr/local/remote/last_function` || LAST=mp3 ;;
esac

echo $LAST > /usr/local/remote/last_function
[ -r /usr/local/remote/lircrc_$LAST ] && cp /usr/local/remote/lircrc_$LAST /usr/local/remote/lircrc
#must restart lircd before mplayer or it will not recieve the signals
/etc/rc.d/rc.remote restart
power_$LAST
