/*
MP3 STATION
 
A plain text Linux/Unix toolset for managing mp3 playback with as little
user interaction as possible.  It was built to handle mp3 playback in a car.
Copyright (C) 2003 David Rao <louigi600@yahoo.it>
 
This file is part of MP3 STATION.
 
MP3 STATION is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
 
MP3 STATION is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with MP3 STATION; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <errno.h>
#include <unistd.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <lirc/lirc_client.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <math.h>
#include <term.h>
#include <stdlib.h>

#ifdef LCURS
#include LCURS
#else
#include <ncurses.h>
#endif

#include "my_functions.h"
                                                                                
#define MAX_PATH 1024

typedef struct directory_listing {
  char *alloc_ptr;
  long n_rows;
  int  r_size;
} dir_list;

struct lirc_config *config;
char *progname;
int VERBOSE=1;        //verbose level

#ifdef TMPD
char TMP_DIR[MAX_PATH]=TMPD;
#else
char TMP_DIR[MAX_PATH]="/tmp/cm3s";
#endif

#ifdef MP3D
  char MP3_DIR[MAX_PATH]=MP3D;
#else
  char MP3_DIR[MAX_PATH]="/media/mp3";
#endif

char STAT_PIPE[MAX_PATH]="stat";   //this must be prefixed with TMP_DIR
extern char PROJ_NAME;


WINDOW *w,*w2,*w3,*w4; //windows
int split;             //no of lines in witch main window is split
int cols,lins;         //line and column size of main window
long count=0,count1=0; //counter for number of entries found in a directry
int max_len=0;         //actual max lenght found while counting
char trk[MAX_PATH],buf[MAX_PATH];
int stat_fd[2];
dir_list dirlist={NULL,0,0};
help load_help={
  "0 : Exit load menu without doing anything",
  "4 : Move up a directory , 6 : Descend into selected directory",
  "2 : Scroll up           , 8 : Scroll down",
  "5 : Load selected file/playlist/directory",
  ""
};

int Is_Playable (char str[MAX_STR]);
void Load ();
long Count_Calls (char str[MAX_STR]); //count calls for alloc mem (dirwalk)
long Store_Ent (char str[MAX_STR]);  //after count store in alloc mem (dirwalk)
int Wshow_Mem (WINDOW *win, dir_list content);
int wshow_help (WINDOW *win,help hlp_matrix);

int wshow_help (win,hlp_matrix)
WINDOW *win;
help hlp_matrix;
{ int i=0;
                                                                                
  clearok(win,TRUE);
  wclear(win);
  wrefresh(win);
  clearok(win,FALSE);
  scrollok(win,FALSE);
  while(strcmp(hlp_matrix[i],"")!=0)
  { wprintw(win,"%s\n",hlp_matrix[i]);
    ++i;
  }
  wrefresh(win);
  scrollok(win,TRUE);
}

void Load ()
{ char *ptr;
  char tbuf2[MAX_PATH];
                                                                                
  getcwd(buf,MAX_PATH);
  count=0;
  max_len=0;
  dirwalk(buf,Count_Calls);
  dirlist.alloc_ptr=NULL;
  if((ptr=(char*)calloc(count,max_len))!=NULL)
  { dirlist.alloc_ptr=ptr;
    dirlist.n_rows=count;
    dirlist.r_size=max_len;
    wrefresh(w3);
    count1=0;
    dirwalk(buf,Store_Ent);
    Wshow_Mem(w2,dirlist);
  } else wprintw(w3,"Failed to allocate memory!\n");
}

long Count_Calls (str)
char str[MAX_STR];
{ long t;
  if(Is_Playable(str)==0)
  { ++count;
    if((t=(strlen(str)+1)) > max_len) max_len=t;  //one extra char for \0
  }
  return(0);
}
                                                                               long Store_Ent (str)
char str[MAX_STR];
{ char *ptr2;
  if(Is_Playable(str)==0)
  { ptr2=dirlist.alloc_ptr + (dirlist.r_size * count1);
     sprintf((char*)ptr2,"%s\0",str);
    ++count1;
  }
}

int Is_Playable (name)
char name[MAX_STR];
{   char *sp;
  char tmps[MAX_STR];
                                                                                 
  if (Is_File(name)==0)
  { if((sp=strrchr(name,'.'))!=NULL)
    { strtolower((char*)++sp,tmps);
      if((strcmp(tmps,"mp3")==0) || (strcmp(tmps,"msl")==0))
        return(0);
      else return(-1);
    } else return(-1);
  }
  else if(Is_Dir(name)==0) return(0);
  else return(-1);
}

int Wshow_Mem (win,content)
WINDOW *win;
dir_list content;
{ long i=0,j=0;
  char *ptr2=NULL;
  int x,y,c;
  int h_line=0;      //selected line for highliting
  int first_line=0;  //first line displayed in window
  char *code;
  char *cmd;
  int ret;
                                                                                 
  getmaxyx(win,y,x);
//  wprintw(win,"%i,%i\n",y,x);
                                                                                 
  nodelay(w3, FALSE);
  scrollok(win,FALSE);

/*  
//101 = e for exiting load menu
    else if (c==101)
    { wprintw(w3,"%c: Exiting load menu!\n",c);
      wrefresh(w3);
      sleep(1);
      if( content.alloc_ptr != NULL ) free(content.alloc_ptr);
      break;
    }
//104 = h for help on present menu 
    else if (c==104) wshow_help(w3,load_help);
*/    
  while (1)
  { clearok(win,TRUE);
    wclear(win);
    wrefresh(win);
    clearok(win,FALSE);
    for(i=0;i<min((content.n_rows - first_line),y);i++)
    { j=i + first_line;
      ptr2=content.alloc_ptr + (content.r_size * j);
      if(i==h_line) wattron(win,A_STANDOUT);
      wprintw(win,"%s\n",(char*)ptr2);
      if(i==h_line) wattroff(win,A_STANDOUT);
    }
    wrefresh(win);
    wrefresh(w3);
    while (lirc_nextcode(&code)==0)
    { if(code==NULL) break;
      while((ret=lirc_code2char(config,code,&cmd))==0 && cmd!=NULL)
      { if( cmd==NULL ) break;
//move up a directory
        if (strcmp(cmd,"cdup")==0)
        { wprintw(w3,"<-: Parent dir listing!\n");
          if( content.alloc_ptr != NULL ) free(content.alloc_ptr);
          chdir("..");
          Load();
          ret=-1;
          break;
        }
//dicend into a directory
        else if (strcmp(cmd,"cddown")==0)
        { wprintw(w3,"->: Descend into directory!\n");
          ptr2=content.alloc_ptr + (content.r_size * (first_line + h_line));
          if(Is_Dir((char*)ptr2)==0)
          { chdir((char*)ptr2);
            if( content.alloc_ptr != NULL ) free(content.alloc_ptr);
            Load();
            ret=-1;
            break;
          }
        }
//scroll up
        else if (strcmp(cmd,"scroll_up")==0)
        { waddch(w3,ACS_UARROW);
          wprintw(w3,": Scroll up\n",ACS_UARROW);
          if(h_line>0) --h_line;
          else if(first_line>0) --first_line;
          ret=-1;
          break;
        }
//scroll down
        else if (strcmp(cmd,"scroll_down")==0)
        { waddch(w3,ACS_DARROW);
          wprintw(w3,": Scroll down!\n");
          if(h_line < min((y - 1),(content.n_rows - first_line - 1))) ++h_line;
          else if(first_line<(content.n_rows - 1))
          { ++first_line;
            if(h_line> (content.n_rows - first_line - 1)) --h_line;
          }
          ret=-1;
          break;
        }
//enter selection
        else if (strcmp(cmd,"enter")==0)
        { wprintw(w3,"ENTER: Plying selection!\n");
          ptr2=content.alloc_ptr + (content.r_size * (first_line + h_line));
          sprintf(buf,"NOP\n#L %s\n",(char*)ptr2);
          write(stat_fd[1],buf,strlen((char*)ptr2)+8);
          if( content.alloc_ptr != NULL ) free(content.alloc_ptr);
          free(code);
          lirc_freeconfig(config);
          lirc_deinit();
          endwin();
          close(stat_fd[1]);
          exit(EXIT_SUCCESS);
        }
//exit 
        else if (strcmp(cmd,"exit")==0)
        { wprintw(w3,"%c: Exiting load menu!\n",c);
          wrefresh(w3);
          if( content.alloc_ptr != NULL ) free(content.alloc_ptr);
          free(code);
          lirc_freeconfig(config);
          lirc_deinit();
          endwin();
          close(stat_fd[1]);
          exit(EXIT_SUCCESS);
        }
//help
        else if (strcmp(cmd,"one")==0) wshow_help(w3,load_help);
      }
      free(code);
      if(ret==-1) break;
    }
  }
  nodelay(w3, TRUE);
  clearok(win,TRUE);
  wclear(win);
  wrefresh(win);
  clearok(win,FALSE);
  scrollok(win,TRUE);
  lirc_freeconfig(config);
}

//initializing window stuff for curses to work
int Init_Windows (percent)
int percent;
{ char buf2;

  w=initscr();            /* initializing window */
  getmaxyx(w,lins,cols);
//this makes sure that the bottomb window can display at leat 5 lines
  split=max(((lins * percent) / 100),(lins  - 7));
  keypad(w, FALSE);
  cbreak();               /* no line buffering */
  noecho();               /* no echoing keys pressed */
  nonl();                 /* no new line translation in windows */
  box(w,ACS_VLINE,ACS_HLINE);
  move(split,1);
  hline(ACS_HLINE,cols-2);
  move(split,0);
  addch(ACS_LTEE);
  move(split,cols -1);
  addch(ACS_RTEE);
  wrefresh(w);
  w2=newwin((split - 1),(cols - 2),1,1);
  scrollok(w2,TRUE);
  w3=newwin((lins - split - 2),(cols - 2),(split + 1),1);
  scrollok(w3,TRUE);
  wmove(w2,0,0);
  keypad(w2, FALSE);
  wrefresh(w2);
  wmove(w3,0,0);
  wrefresh(w3);
  nodelay(w3, TRUE);
  keypad(w3,TRUE);
}


int main(int argc, char *argv[])
{ char ts[MAX_PATH];
  int c,d;
  int x,y;
  int tmp;

  progname=argv[0];
  drop_privs();
  sprintf(ts,"%s/%s",TMP_DIR,STAT_PIPE);
  strcpy(STAT_PIPE,ts);

  if(argc>2)
  {
    fprintf(stderr,"Usage: %s <config file>\n",progname);
    exit(EXIT_FAILURE);
  }
  if(lirc_init("lirc_client",1)==-1) exit(EXIT_FAILURE);
  if(lirc_readconfig(argc==2 ? argv[1]:NULL,&config,NULL)!=0)
  { lirc_deinit();
    exit(EXIT_FAILURE);
  }

//opening status pipe with nodelay, do not want this to hang if cm3s is
//not running
  stat_fd[1]=open(STAT_PIPE,O_NDELAY | O_WRONLY);

  Init_Windows(71);
 
//This displays some basic information on the GPL in the bottomb window
  wprintw(w3,"MP3 STATION project, Copyright (C) 2003 David Rao\n");
  wprintw(w3,"MP3 STATION comes with ABSOLUTELY NO WARRANTY.\n");
  wprintw(w3,"This is free software, and you are welcome to redistribute it\n");
  wprintw(w3,"under the conditions of the GNU General Public License; read COPYING.\n");
  wrefresh(w3);
  wrefresh(w2);
//  nodelay(w3, TRUE);
  chdir(MP3_DIR);
  Load();

  lirc_deinit();
  endwin();
  close(stat_fd[1]);

  exit(EXIT_SUCCESS);
}
