/*
MP3 STATION

A plain text Linux/Unix toolset for managing mp3 playback with as little
user interaction as possible.  It was built to handle mp3 playback in a car.
Copyright (C) 2003 David Rao <louigi600@yahoo.it>

This file is part of MP3 STATION.

MP3 STATION is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

MP3 STATION is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MP3 STATION; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <dirent.h>
#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/ioctl.h>
#include <sys/time.h>

#ifdef RTC
#include <linux/rtc.h>
#endif
//#include <linux/file.h>
//#include <linux/fs.h>

#define MAX_STR 1024

//Typedef
typedef struct msgbuffer {
  long mtype;           /* message type, must be > 0 */
  char mtext[MAX_STR];  /* message data */
} my_msgbuf;
typedef char help[][80];

int drop_privs (void);
int be_daemon (void);
void close_stdioe (void);
int realloc_stdioe (int nfdi, int nfdo, int nfde);
int Is_Dir (char name[MAX_STR]);
int Is_File (char name[MAX_STR]);
int Read_Ln (int fd , char buf[MAX_STR]);
int Handle_Error (int err , char originated_from[MAX_STR]);
char *strtolower (char str[MAX_STR] , char ret[MAX_STR]);
char *strtoupper (char str[MAX_STR] , char ret[MAX_STR]);
long dirwalk (char dir[MAX_STR], long (*func)(char*));
//void add_line_to_window (WINDOW *win, char str[MAX_STR]);
int msg_del_queue (char queue);
int sendmsg (char queue, char msg[MAX_STR]);
int readmsg (char queue, char msg[MAX_STR]);
int min (int a, int b);
int max (int a, int b);
char *path2tok (char src[MAX_STR], char dst[MAX_STR]);
long get_newest_mtime (char name[MAX_STR]);
char *cut_space(char dst[MAX_STR], char src[MAX_STR]);
char *rm_space(char dst[MAX_STR], char src[MAX_STR]);
int other_running(char name[256]);
int fuser(char pathname[MAX_STR]);
int sleep64(int counter);
int atox(char *hex_str);
void eat_cpu();
