#!/bin/sh
TARGET=${1:-"/"}
[ "$TARGET" != "/" ] && TARGET=`echo "$TARGET" | sed -e 's/\/$//g'`
REQUIREMENTS="/etc/passwd /etc/group /etc/rc.d/rc.local"

###########################
##checking the requirements

MISSING=0
for FILE in $REQUIREMENTS
do
  if [ ! -f ${TARGET}$FILE -o ! -w ${TARGET}$FILE ] 
  then
    MISSING=1
    echo "Error: ${TARGET}$FILE not found or does not have the correct perms!"
  fi
done

if [ $MISSING -ne 0 ]
then
  echo "Some required files were missing ... is it ok to go on ?"
  echo "Press ENTER to continue or ^C to abort !"
  read
fi

###############################
##here go any pre install tasks

###################################################
##this will unpack the stuff into the correct place
##and execute the target/install/doinst script for 
##any other package special requirements

mkdir -p $TARGET

FILES=`find . -name "*.tgz" -print`

[ "$TARGET" = "" ] && TMP_TARGET="/" || TMP_TARGET=$TARGET
for FILE in $FILES
do
  tar xvzf $FILE -C ${TMP_TARGET}
  ( cd $TARGET ; . install/doinst.sh )
done

################################
##here go anu post install tasks

rm -rf ${TARGET}/install/slack-desc ${TARGET}/install/doinst.sh
[ `ls ${TARGET}/install | wc -l` -eq 0 ] && rm -rf ${TARGET}/install
