/*
MP3 STATION

A plain text Linux/Unix toolset for managing mp3 playback with as little
user interaction as possible.  It was built to handle mp3 playback in a car.
Copyright (C) 2003 David Rao <louigi600@yahoo.it>

This file is part of MP3 STATION.

MP3 STATION is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

MP3 STATION is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MP3 STATION; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <stdio.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <signal.h>
#include <string.h>
#include <linux/lp.h>
#include <linux/ppdev.h>
#include <errno.h>
#include <sys/io.h>

extern int cmd_fd[2],stat_fd[2];
extern char STAT_PIPE[];

char *x2b(int input, char *output)
{ char ts[80]="";
  int rest;
  
  if(input==0) sprintf(output,"00000000");
  while(input > 0)
  { rest= input % 16;
    input = input / 16;
    if(rest==15) sprintf(ts,"1111%s",output);
    if(rest==14) sprintf(ts,"1110%s",output);
    if(rest==13) sprintf(ts,"1101%s",output);
    if(rest==12) sprintf(ts,"1100%s",output);
    if(rest==11) sprintf(ts,"1011%s",output);
    if(rest==10) sprintf(ts,"1010%s",output);
    if(rest==9) sprintf(ts,"1001%s",output);
    if(rest==8) sprintf(ts,"1000%s",output);
    if(rest==7) sprintf(ts,"0111%s",output);
    if(rest==6) sprintf(ts,"0110%s",output);
    if(rest==5) sprintf(ts,"0101%s",output);
    if(rest==4) sprintf(ts,"0100%s",output);
    if(rest==3) sprintf(ts,"0011%s",output);
    if(rest==2) sprintf(ts,"0010%s",output);
    if(rest==1) sprintf(ts,"0001%s",output);
    if(rest==0) sprintf(ts,"0000%s",output);
    sprintf(output,"%s",ts);
  }
  if(strlen(output)<8) sprintf(ts,"0000%sb",output);
  else sprintf(ts,"%sb",output);
  strcpy(output,ts);
  return((char*) output);
}

int hw_conv_ctrl(int input)
{ int mask=11;
  int output=0;

  output=input ^ mask;
  return(output);
}

int hw_conv_stat(int input)
{ int mask=128;
  int output=0;

  output=input ^ mask;
  return(output);
}

//this function returnes the number of the button pressed
//there are 5 lines : so a max of 32 buttons can be coded
//I'll probably be using a 74ls147 so I'll only be using 10 buttons
//coded in to Binary Code Decimal (BCD) 
//all lines should be made rest high when no button is pressed
int get_button_pressed (int base)
{ int status;

  status=(hw_conv_stat(inb(base + 1))) >> 3;
  while(((hw_conv_stat(inb(base + 1))) >> 3) != 31) {}
  return(status); 
}

int check_hw(int base)
{ int status;
  if((status=(hw_conv_stat(inb(base + 1))) >> 3) == 31)
    return(0);
  else return(-1);
}

//this must be done before dropping root privs
//and possibly after forking as in documentation it is
//stated that this ioperm is lost through forks
int set_ioperms(int base)
{ if (ioperm(base,7,1)) return(0);
  else return(-1);
}

void spc_manager(int base)
{ int val,old_val=-1;
  char **mixer_str[2];

//this will sleep until father opens the other side of the pipes
  stat_fd[1]=open(STAT_PIPE,O_WRONLY); 
  while(1)
  { val=get_button_pressed(base);
    if((val != old_val) && (val != 31)) 
    { switch (val) 
      { case 30:
            write(stat_fd[1],"@P 0",4);
          break;
#ifdef MIXER
        case 29:
            mixer_str[0]=(char**)"vol";
            mixer_str[1]=(char**)"+2";
            cmd_mixer(2,mixer_str); 
          break;
        case 27:
            mixer_str[0]=(char**)"vol";
            mixer_str[1]=(char**)"-2";
            cmd_mixer(2,mixer_str);
          break;
#endif
        case 23:
            write(stat_fd[1],"#E PREV",7);
          break;
      }
    }
    old_val=val;
    sleep64(1);
  }
}

void data_out(int val, int base)
{ outb(val,base); }

//this will allow the data lines to be used as input
//the actual bidirectional capabilities on the data lines are hardware related
//and may not actually be fully bidirectional on your hardware
//but at least you will be able to use them as input
void set_bdl(int base)
{ int prev_setting;
 
  prev_setting=inb(base + 2);
  outb((prev_setting ^ 32), base + 2);  
}

int old_main()
{ int lstate = 0;
  int i = 0;
  pid_t pid;
  int base=0x378;
  int val=255,val2;
  char str[80]="";
  int mode;

  printf("%s \n",x2b(inb(base),(char*)str));
  strcpy(str,"");
  printf("%s \n",x2b(inb(base + 1),(char*)str));
  strcpy(str,"");
  printf("%s \n",x2b(inb(base + 2),(char*)str));
  strcpy(str,"");
  printf("%s \n",x2b(inb(base + 3),(char*)str));
  strcpy(str,"");
  printf("%s \n",x2b(inb(base + 4),(char*)str));
  strcpy(str,"");
  printf("%s \n",x2b(inb(base + 5),(char*)str));
  strcpy(str,"");
  printf("%s \n",x2b(inb(base + 6),(char*)str));
  strcpy(str,"");

  exit(0);
}
